from xf import *

# x{}
for i in range(0, 1025):
    exec('x{} = xf({})'.format(i, i))

# For numbers bigger than 1025, use x1*
# Example: x1*531441/524288

# 3.5.7.11

j8    =  w8 =    x2/1

j7u7  =  r7 =   x27/14
j3o7  = Lw7 =  x243/128
j5o7  =  y7 =   x15/8
j11u7 = lu7 =   x81/44
j11o7 = lo7 =   x11/6
j5u7  =  g7 =    x9/5
j3u7  = sw7 =   x16/9
j7o7  =  z7 =    x7/4
               
j7u6  =  r6 =   x12/7
j3o6  = Lw6 =   x27/16
j5o6  =  y6 =    x5/3
j11u6 = lu6 =   x18/11
j11o6 = lo6 =   x44/27
j5u6  =  g6 =    x8/5
j3u6  = sw6 =  x128/81
j7o6  =  z6 =   x14/9

j7u5  =  r5 =   x32/21
j3o5  = Lw5 =    x3/2
j5o5  =  y5 =   x40/27
j11u5 = lu5 =   x16/11
j11o5 = lo5 =   x99/64
j5u5  =  g5 =   x64/45
j3u5  = sw5 = x1024/729
j7o5  =  z5 =  x112/81
               
j7u4  =  r4 =   x81/56
j3o4  = Lw4 =  x729/512
j5o4  =  y4 =   x45/32
j11u4 = lu4 =  x243/176
j11o4 = lo4 =   x11/8
j5u4  =  g4 =   x27/20
j3u4  = sw4 =    x4/3
j7o4  =  z4 =   x21/16
               
j7u3  =  r3 =    x9/7  # L
j3o3  = Lw3 =   x81/64 # L
j5o3  =  y3 =    x5/4  # L
j11u3 = lu3 =   x27/22 # L
j11o3 = lo3 =   x11/9  # s
j5u3  =  g3 =    x6/5  # s
j3u3  = sw3 =   x32/27 # s
j7o3  =  z3 =    x7/6  # s
               
j7u2  =  r2 =    x8/7
j3o2  = Lw2 =    x9/8
j5o2  =  y2 =   x10/9
j11u2 = lu2 =   x12/11
j11o2 = lo2 =   x88/81
j5u2  =  g2 =   x16/15
j3u2  = sw2 =  x256/243
j7o2  =  z2 =   x28/27

j1    =  w1 =    x1/1

# Some Chords
vM   = xf('4:5:6')
pm   = xf(  '10:12:15')
vm   = xf('6:7:9')
pM   = xf(  '14:18:21')
v7   = xf('4:5:6:7')
p7   = xf('70:90:105:126') # xf([1/1, 9/7, 3/2, 9/5]).colon()
vM7  = xf('8:10:12:15')
pm7  = xf(  '10:12:15:18')
vm7  = xf('12:14:18:21')
pM7  = xf(   '14:18:21:27')
v9   = xf('5:6:7:8:9')
p9   = xf('140:180:210:252:315') # xf([1/1, 9/7, 3/2, 9/5, 9/4]).colon()
vM9  = xf('8:10:12:15:18')
pm9  = xf(  '20:24:30:36:45')
vm9  = xf('12:14:18:21:27')
pM9  = xf(   '28:36:42:54:63')
v11  = xf('16:20:24:28:36:45')
p11  = xf('280:360:405:420:504:630') # xf([1/1, 9/7, 3/2, 9/5, 9/4, 81/56]).colon()
vM11 = xf('16:20:24:30:36:45')
pm11 = xf(   '20:24:30:36:45:54')

for i in range(8):
    for c in 'ABCDEFG':
        exec("{}{} = Pitch('{}{}')".format(c, i, c, i))

c = Cents(1)
Hz = Hertz(1)

import mido
from time import sleep
mdm = mido.Message.from_bytes

class XMD:
    def __init__(self):
        self.oport = mido.open_output('xenedoji', virtual=True)
        self.delay = 2
        self.reference_pitch = Pitch('A4')
        self.reference_rate = x1/1
        self.vel = 0x60

    def play(self, *score):
        voice_number = len(score)
        for note_i in range(len(score[0])):
            voices_notes = []
            for voice_i in range(voice_number):
                voice_note = score[voice_i][note_i]
                if isinstance(voice_note, Pitch) or isinstance(voice_note, Ratio) or voice_note != 0:
                    voices_notes.append(voice_note)
                else:
                    voices_notes.append(0)

            if voices_notes:
                try:
                    self.hx9(voices_notes)
                    sleep(self.delay)
                    self.hx8(voices_notes)
                except KeyboardInterrupt:
                    self.hx8(voices_notes)

    def hx9(self, notes):
        if notes:
            if len(notes) > 15:
                print("16+ part polyphony not yet supported.")
            for i in range(min(len(notes), 15)):
                if notes[i]:
                    if isinstance(notes[i], Cents) or isinstance(notes[i], Interval94) or isinstance(notes[i], Interval12):
                        note = self.reference_pitch + notes[i]
                    elif isinstance(notes[i], Pitch):
                        note = notes[i]
                    else: # Ratio or float
                        note = self.reference_pitch * notes[i]
                    pb = round((8192 * note.cents.value/100/48) + 8192)
                    self.send(mdm([0xe0|(i+1), pb&127, pb>>7]))
                    self.send(mdm([0x90|(i+1), note.midi(), self.vel]))
                    self.send(mdm([0xa0|(i+1), note.midi(), self.vel]))

    def hx8(self, notes):
        if notes:
            for i in range(min(len(notes), 15)):
                if notes[i]:
                    if isinstance(notes[i], Cents) or isinstance(notes[i], Interval94) or isinstance(notes[i], Interval12):
                        note = self.reference_pitch + notes[i]
                    elif isinstance(notes[i], Pitch):
                        note = notes[i]
                    else: # Ratio or float
                        note = self.reference_pitch * notes[i]
                    self.send(mdm([0x80|(i+1), note.midi(), self.vel]))

    def send(self, msg):
        self.oport.send(msg)


xmd = XMD()
play = xmd.play
